from __future__ import with_statement
from getopt import getopt
from getopt import GetoptError
import sys
from StringIO import StringIO
from filedepot import FileDepot
from fgconfig import XmlConfig

def getUsage():
    output = StringIO()
    print>>output
    print>>output, "Usage: fgen [options] arguments\n"
    XmlConfig().printOptionUsage(output)
    print>>output
    output.write("Please report bugs to <wanjunfeng@gmail.com>, thanks!")
    print>>output
    content = output.getvalue()
    output.close()
    return content

def createGenerator(pkg, className, *args):
    exec "import %s" % pkg
    exec "instance = %s.%s(*args)" % (pkg, className)
    return instance

def main():
    if len(sys.argv) == 1:
        sys.exit(getUsage())

    parser = XmlConfig()
    try:
        opts, args = getopt(sys.argv[1:], parser.getShortOptions(), parser.getLongOptions())
        options = parser.getOptions()
        for option in options:
            pkg = option[3]
            slotClass = option[4]
            instance = createGenerator(pkg, slotClass, opts, args)
            if instance.isRightGenerator():
                instance.run()
                break
    except GetoptError, ex:
        print "Error: ", ex
        sys.exit(getUsage())


if __name__ == "__main__":
    try:
        main()
    except Exception, ex:
        print "Error: ", ex
        print "Rolling back..."
        FileDepot().removeAllFromDisk()
        print "\nPlease report bugs to <wanjunfeng@gmail.com>, thanks!"
