from getopt import GetoptError
from filedepot import FileDepot
from fgutils import dieOnExists
from templateparser import TemplateParser
from filegenerator import FileGenerator 

class MakefileGen(FileGenerator):
    def __init__(self, opts, args):
        FileGenerator.__init__(self, opts, args)

    def getOptionTuple(self):
        return ("-m", "--makefile")

    def run(self):
        if len(self.__args__) > 1:
            raise GetoptError("too many arguments")
            
        makefile = "makefile"
        if len(self.__args__) == 1:
            makefile = self.__args__[0]
    
        dieOnExists(makefile)
        FileDepot().add(makefile)
        parser = TemplateParser("makefile", makefile)
        parser.parse()
        print "\t" + makefile + "\t\t\t\t[OK]"
